// HC11.cpp - for Small C++ by Walter O. Krawec
// Contains several static functions allowing you to easily access
// various functions of the HC11 such as setting up the A/D converter
// or a ~1/2 second delay

#ifndef HC11_H_
#define HC11_H_

class HC11
{
public:
	static void setupAD()						// setup the A/D converter
	{
		__AOC {
			ASM: ldaa #$80
				 staa $1039;
		}
	}
	static byte getAD(byte* port, byte pin)		// get an A/D conversion (recommend  using the io::Analog class instead defined in IO.h)
	{
		__AOC {
			GET pin;
			ASM: ldaa 0,x
				 staa $1030;
			LABEL lblHC11GETAD;
			ASM: ldaa $1030
				 ora  #$7f
				 cmpa #$ff
				 bne  lblHC11GETAD;
		}

		return (*port);
	}
	static void delay()							// delays for ~1/2 second (using 8MHz clock)
	{
		byte c;
		__AOC {
			GET c;
			ASM: ldy #$ffff;
			LABEL lblHC11_D1;
			ASM: dey
				 iny
				 dey
				 bne lblHC11_D1;
		}
	}

	static void poke(byte* address, byte value)
	{
		*address = value;
	}
	static byte peek(byte* address)
	{
		return (*address);
	}
}

#endif