// IO.cpp - by Walter O. Krawec for Small C++
// includes code for accessing an HC11's analog or digital inputs (no outputs yet...)
//

#ifndef IO_CPP_
#define IO_CPP_

#include <IO.h>

namespace io
{
	class Digital
	{
	public:
		void setup(byte* Port, byte PinMask)
		{
			m_Port = Port;
			m_PinMask = PinMask;
		}

		byte get()
		{
			if(!(*m_Port & m_PinMask)) {
				return (1);
			}
			return (0);
		}
	}

	class Analog
	{
	public:
		void setup(byte* ADPort, byte ADPin)
		{
			m_ADPort = ADPort;
			m_ADPin = ADPin;
		}

		byte get()
		{
			byte pin;
			pin = m_ADPin;
			__AOC {
				GET pin;
				ASM: ldaa 0,x
					 staa $1030;
				LABEL lblCANALOGGET;
				ASM: ldaa $1030
					 ora  #$7f
					 cmpa #$ff
					 bne  lblCANALOGGET;
			}

			return (*m_ADPort);
		}
	}
}

#endif