// Byte.cpp - written for Small C++
// contains code for basic operators on the byte data type
// this file is not needed really as all of these operators are included
// in the AOC file (saving time and memory).  However I included them here
// so you can get an idea of how to define your own operators.

#ifndef _BYTE_CPP_
#define _BYTE_CPP_

#include <Byte.h>

class byte
{
	byte operator+ (byte* a, byte* b)
	{
		byte c;
		__AOC {
			GET a;
			INDIRECT;
			ASM: ldaa 0,x
				 XGDY;
			GET b;
			INDIRECT;
			ASM: XGDY
				 adda 0,x;
			GET c;
			ASM: staa 0,x;
		}

		return (c);
	}

	byte operator- (byte* a, byte* b)
	{
		byte c;
		__AOC {
			GET a;
			INDIRECT;
			ASM: ldaa 0,x
				 XGDY;
			GET b;
			INDIRECT;
			ASM: XGDY
				 suba 0,x;
			GET c;
			ASM: staa 0,x;
		}

		return (c);
	}

	byte operator& (byte* a, byte* b)
	{
		byte c;
		__AOC {
			GET a;
			INDIRECT;
			ASM: ldaa 0,x
				 XGDY;
			GET b;
			INDIRECT;
			ASM: XGDY
				 anda 0,x;
			GET c;
			ASM: staa 0,x;
		}

		return (c);
	}

	byte operator== (byte *a, byte *b)
	{
		byte c;
		__AOC {
			GET a;
			INDIRECT;
			ASM: ldaa 0,x
				 XGDY;
			GET b;
			INDIRECT;
			ASM: XGDY
				 cmpa 0,x
				 beq lblBYTE055a
				 ldaa #$00
				 jmp lblBYTE055b;
			LABEL lblBYTE055a;
			ASM: ldaa #$01;
			LABEL lblBYTE055b;
			GET c;
			ASM: staa 0,x;
		}

		return (c);
	}

	byte operator> (byte *a, byte *b)
	{
		byte c;
		__AOC {
			GET a;
			INDIRECT;
			ASM: ldaa 0,x
				 XGDY;
			GET b;
			INDIRECT;
			ASM: XGDY
				 cmpa 0,x
				 bgt lblBYTE070a
				 ldaa #$00
				 jmp lblBYTE070b;
			LABEL lblBYTE070a;
			ASM: ldaa #$01;
			LABEL lblBYTE070b;
			GET c;
			ASM: staa 0,x;
		}

		return (c);
	}

	byte operator< (byte *a, byte *b)
	{
		byte c;
		__AOC {
			GET a;
			INDIRECT;
			ASM: ldaa 0,x
				 XGDY;
			GET b;
			INDIRECT;
			ASM: XGDY
				 cmpa 0,x
				 blt lblBYTE060a
				 ldaa #$00
				 jmp lblBYTE060b;
			LABEL lblBYTE060a;
			ASM: ldaa #$01;
			LABEL lblBYTE060b;
			GET c;
			ASM: staa 0,x;
		}

		return (c);
	}

	byte* operator[] (byte* base, byte* offset)
	{
		byte *c;
		__AOC {
			GET base;
			ASM: ldd 0,x;
			GET offset;
			ASM: addd 0,x;
			GET c;
			ASM: std 0,x;
		}
		return (c);
	}
}

#endif