// Memory_c.cpp - by Walter O. Krawec
// same as Memory.h + Memory.cpp except written in C++ (instead of assembler)
// this version requires MUCH more memory to use than the assembler version (Memory.h), however
// is far easier to read and understand since the code is in C++.  I included this version only so
// that you can see how the smaller and faster Memory.h works.

#include <memory_c.h>

namespace memory
{
	class heap
	{
		void* malloc(int16 amount)
		{
			memory::heap::node* node, *save;
			void* p;
			node = head;
			save = 0x0000;
			int16 oldSize;
			while(node != 0x0000)
			{
				if(node.free == 1)
				{
					if(node.blockSize >= amount+node.size)
					{
						node.free = 0;
						oldSize = node.blockSize;
						node.blockSize = amount;
						save = node.next;
						p = node + amount + node.size;
						node.next = p;
						node.next.next = save;
						node.next.free = 1;
						node.next.blockSize = oldSize-(amount+node.size);
						p = node + node.size;
						return (p);
					}
				}

				node = node.next;
			}

			return (0x0000);
		}

		void free(void* p)
		{
			memory::heap::node* node;
			node = p-node.size;
			node.free = 1;
		}
	}
}