// Memory_c.h - by Walter O. Krawec
// same as Memory.h + Memory.cpp except written in C++ (instead of assembler)
// this version requires MUCH more memory to use than the assembler version (Memory.h), however
// is far easier to read and understand since the code is in C++.  I included this version only so
// that you can see how the smaller and faster Memory.h works.

#ifndef MEMORY_H_
#define MEMORY_H_

#include <int16.h>

namespace memory
{
	class heap
	{
		struct node
		{
			int16 blockSize;			// size of this block
			memory::heap::node* next;	// pointer to next block
			byte free;					// 1 if this is a free address, 0 otherwise
		}

	private:
		memory::heap::node* head;

	public:
		void setup(memory::heap::node* head, int16 maxSize)
		{
			this.head = head;
			this.head.free = 1;
			this.head.next = 0x0000;
			this.head.blockSize = maxSize;
		}

		void heap()
		{
			setup(0x7fff, 0x1000);
		}
		void* malloc(int16 amount);
		void free(void* p);
	}
}

#endif