// Test2.cpp is a simple program that shows how to print out numbers.  To use this program, run a terminal editor on your PC
//

#include <SCI.h>			// SCI.h contains code to use the HC11's serial port
#include <StandardIO.h>		// StandardIO.h contains code to print out numbers
#include <int16.h>			// int16.h defines the 16-bit integer variable type
#include <Standard.h>		// Standard.h contains code so that we can use any type of array

class TestProgram2
{
	static void main()
	{
		byte a;			// declare 'a' as a byte variable
		byte arr[10];	// declare 'arr' as an array of 10 bytes
		int16 i, j;		// declare 'i' and 'j' as int16 variables

		a = 5;				// set 'a' to 5
		i = 10;				// set 'i' to 10
		i = (int16)a + 32;	// set 'i' to 'a' plus 32 (37) - don't forget to cast to int16 (since 'a' is a byte)
		j = i / 2;			// divide 'i' by two and set the result to 'j' (no need for a cast here since 'i' is already an int16

		arr[0] = 0xff;		// set the first element of 'arr' to 0xff (255)
		arr[9] = 22;		// set the last element of 'arr' to 22

		io::SCI.setup();					// setup the HC11's SCI port for use

		io::cout.printNumber((int16) a);	// print out the number stored in 'a'
		io::cout.endl();					// new line
		io::cout.printNumber(i);			// and print out the other two values followed by a new line.
		io::cout.endl();
		io::cout.printNumber(j);
		io::cout.endl();

		// now print out the numbers in the array:
		// first store unique numbers in each element:
		byte counter;
		counter = 0;
		while(counter < 10)		// ten elements in this array...
		{
			arr[counter] = counter + 1;
			counter = counter + 1;
		}

		// and then print them out:
		counter = 1;
		while(counter <= 10)
		{
			io::cout.printNumber((int16) arr[counter-1]);
			io::cout.endl();
			counter = counter + 1;
		}
	}
}