// Test4.cpp a very simple program showing off virtual functions, inheritance, and polymorphism.
//

// DEFINE the BaseClass with one virtual function (doSomething) and one byte variable
// this would normally be in a header file (.h) - not required, but it keeps things organized
#include <SCI.h>
class BaseClass
{
public:
	virtual void doSomething();
	byte i;
}
// DEFINE the DerivedClass which inherits from BaseClass and overrides the virtual function
// since this inherits from BaseClass, it also has access to byte i.
// this would normally be in a header file (.h)
class DerivedClass uses BaseClass
{
public:
	virtual void doSomething();
}

// IMPLEMENT the BaseClass
// this would normally be in a seperate .cpp file
class BaseClass
{
	virtual void doSomething()	// just set 'i' to zero
	{
		io::SCI.out('a');
		i = 0;
	}
}
// IMPLEMENT the DerivedClass
// normally in a seperate .cpp file
class DerivedClass
{
	virtual void doSomething()	// just set 'i' to one
	{
		io::SCI.out('b');
		i = 1;
	}
}

class TestProgram4
{
	static void main()
	{
		io::SCI.setup();
		BaseClass *p;			// create a pointer to a BaseClass object
		BaseClass base;			// create an instance of a BaseClass object
		DerivedClass derived;	// create an instance of a DerivedClass object

		p = &base;				// 'p' now points to 'base'
		p.doSomething();		// p.i now equals 0 since base.doSomething() was run...

		p = &derived;			// 'p' now points to 'derived'
		p.doSomething();		// p.i now equals 1 since derived.doSomething was run...
	}
}